function [tmpx, mode, loop] = gdec(b, y, s, rc, cr, rw, cw, cN, H, sft, mul, add)

THL = 100;
THS = 5;
LBA = 1e-9;
LBI = 1e-9;

[q,Q] = size(sft);
n = length(y);
m = length(s);
rwmax = max(rw);

pmf = get_pmf_lap(b,y,Q,LBI);

%rmin = -sum(sum(pmf.*log2(pmf)))/n/q;
%disp(rmin);

qa = zeros(m,rwmax,Q);
ra = zeros(m,rwmax,Q);
fna_all = zeros(n, Q);
for i=1:n 
    for k=1:cw(i)
        qa(cr(i,k),cN(i,k),:) = pmf(i,:);
    end
end
fQa = zeros(rwmax,Q);

tmpx = y;
nsames = 0;
for loop=1:THL        
    % work on s-nodes
    for j=1:m 
        prod = ones(1,Q);
        % from x-nodes
        for k=1:rw(j)
            fQa(k,mul(H(j,k),:)) = qa(j,k,:);
            fQa(k,:) = gntt(fQa(k,:),sft);
            prod = prod.*fQa(k,:);
        end
        % to x-nodes
        for k=1:rw(j)
            fRa = prod./fQa(k,:);
            fRa = gntt(fRa,sft);
            ra(j,k,:) = fRa(add(s(j)+1, mul(H(j,k),:)))/Q; 
        end
    end


    % work on x-nodes

    ndifs = 0;
    for i=1:n      
        prod = pmf(i,:);
        % from s-nodes
        for k=1:cw(i)
            prod = prod .* reshape(ra(cr(i,k),cN(i,k),:),[1,Q]);
        end
        % to s-nodes
        for k=1:cw(i)
             tmp = prod ./ reshape(ra(cr(i,k),cN(i,k),:),[1,Q]); 
             tmp(tmp<LBA) = LBA;
             qa(cr(i,k),cN(i,k),:) = tmp/sum(tmp);
        end  
        % hard decision
        [maxp, argmaxa] = max(prod);
        if tmpx(i)~=(argmaxa-1)
            tmpx(i) = (argmaxa-1);
            ndifs = ndifs + 1;
        end
        
        %add for swbp by sbw
        fna_all(i,:)=prod/sum(prod);
    end


    % convergence test

    if ndifs
        tmps = enc(tmpx, rw, rc, H, q);
        if sum(s~=tmps)==0
            mode = 0;   % good convergence
            return; 
        else
            nsames = 0;
        end
    else
        if nsames>(THS-2)
            mode = 1;   % bad convergence
            return; 
        else
            nsames = nsames+1;
        end
    end
 %tic   
   %add for swbp by sbw
     outb=gswbp_lap(y, fna_all);
     pmf=get_pmf_lap(outb, y, Q, LBI);
 %toc

end

mode = 2; % slow convergence
return;