%add for swbp by sbw
function outb = gswbp_lap(y,  fna_all)
[n,Q] = size(fna_all);
 
%pmf 2 dst
dst=zeros(1,n);
for i=1:n
    s=fna_all(i,(1:Q)).*(abs((1:Q)-y(i)));
    dst(i)=sum(s);
end
%s=fna_all.*(abs(repmat((1:Q), n,1)-repmat(y',1,n)));
%dst=(sum(s,2))';

%[Rmin_lap, outb]=getb(dst, n, 2*2);
u=4:floor((n-1)/2);
u=gpuArray(single(u));

    function rate= getb(n, u)        
        temp=dst(1);
        for j=2:(u+1)
            temp=temp+dst(j);
        end    
        b1 = max(realmin, (temp-dst(1))/u);
        rate = dst(1)/b1+log(b1);

        for i=2:(u+1)           % 2 to u+1
            temp= temp+dst(i+u);
            bi = max(realmin, (temp-dst(i))/(i+u));
            rate=rate+dst(i)/bi+log(bi);
        end

        for i=(u+2):(n-u)           % u+2 to n-u
            temp= temp+dst(i+u)-dst(i-u-1);
            bi = max(realmin, (temp-dst(i))/(2*u));
            rate=rate+dst(i)/bi+log(bi);
        end

        for i=(n-u+1):n           % n-u+1 to n
            temp= temp-dst(i-u-1);
            bi = max(realmin, (temp-dst(i))/(n-1-i+u));
            rate=rate+dst(i)/bi+log(bi);
        end
    end

grate = arrayfun(@getb, n, u);
rate=gather(grate);
[Rmin_lap, bestu]= min(rate);

b=zeros(1,n);
j=1:bestu+1;
temp=sum(dst(j));
b(1) = max(realmin, (temp-dst(1))/bestu);


ii=(2+bestu):(1+2*bestu);   % nodes 2 to u+1
b2=dst(ii);                
tmpVect=cumsum(b2)+temp;
b2=(tmpVect-b2)./ii;
b2= max(realmin, b2);
b(2:bestu+1)=b2;

i=(bestu+2):(n-bestu);                 % u+2 to n-u
tmp1=tmpVect(bestu);
pu1=dst((2+2*bestu):n);
pu2=dst(1:(n-2*bestu-1));
tmpVect=cumsum(pu1)-cumsum(pu2)+tmp1;
pu=(tmpVect-dst((bestu+2):(n-bestu)))/(2*bestu);
b((bestu+2):(n-bestu))=pu;

tmp2=tmpVect(n-2*bestu-1);               % nodes (n-u+1) to n
pn=dst((n-2*bestu):(n-bestu-1));
tmpVect=tmp2-cumsum(pn);
pn=(tmpVect-dst((n-bestu+1):n))./((2*bestu-2):(-1):(bestu-1));
b((n-bestu+1):n)=pn;

outb=b;

end

function [rate, b] = getb(dst, n, u)
    b=zeros(1,n);
    temp=dst(1);
    for j=2:(u+1)
        temp=temp+dst(j);
    end    
    b(1) = max(realmin, (temp-dst(1))/u);
    rate = dst(1)/b(1)+log(b(1));
    
    for i=2:(u+1)           % 2 to u+1
        temp= temp+dst(i+u);
        b(i) = max(realmin, (temp-dst(i))/(i+u));
        rate=rate+dst(i)/b(i)+log(b(i));
    end
    
    for i=(u+2):(n-u)           % u+2 to n-u
        temp= temp+dst(i+u)-dst(i-u-1);
        b(i) = max(realmin, (temp-dst(i))/(2*u));
        rate=rate+dst(i)/b(i)+log(b(i));
    end
    
    for i=(n-u+1):n           % n-u+1 to n
        temp= temp-dst(i-u-1);
        b(i) = max(realmin, (temp-dst(i))/(n-1-i+u));
        rate=rate+dst(i)/b(i)+log(b(i));
    end  
end

