clc;
clear;

% rw: row weight; cw: col weight 
%[rc, cr, rw, cw, rN, cN] = loadTG('reg2.256.128.txt');
[rc, cr, rw, cw, rN, cN] = loadTG('reg2.512.256.txt');
%[rc, cr, rw, cw, rN, cN] = loadTG('reg2.1024.512.txt');
%[rc, cr, rw, cw, rN, cN] = loadTG('reg2.2048.1024.txt');
[n, cwmax] = size(cr); 
[m, rwmax] = size(rc);

q = 8;
Q = 2^q;
H = randi(Q-1, size(rc));

sft = nttsft(Q);
add = gfadd(Q);
mul = gfmul(Q);


% pool = parpool;
b = 2;
%tic
for l=1:1
    x = randi(Q,[1,n]) - 1;
    z = sqrt(2)*b * randl([1,n]); 
    y = round(x+z);
    y(y<0) = 0; 
    y(y>=Q) = Q-1;
    s = enc(x, rw, rc, H, q);
   disp('sequential algorithm:');  
  tic;
       
     [tmpx, mode, loop] = dec(b, y, s, rc, cr, rw, cw, cN, H, sft, mul, add); 
  toc
   disp(['errors =',num2str(sum(abs(tmpx-x)))]);    
    disp(['mode=',num2str(mode)]);
    disp(['loop=',num2str(loop)] );
    
  disp('parallel algorithm:'); 
  tic     
   [tmpx, mode, loop] = gdec(b, y, s, rc, cr, rw, cw, cN, H, sft, mul, add);
  toc
    
    disp(['errors =',num2str(sum(abs(tmpx-x)))]);    
    disp(['mode=',num2str(mode)]);
    disp(['loop=',num2str(loop)] );
end
%toc;