%add for swbp by sbw
function outb = swbp_lap(y,  fna_all)
[n,Q] = size(fna_all);
 
%pmf 2 dst
dst=zeros(1,n);
for i=1:n
    s=fna_all(i,(1:Q)).*(abs((1:Q)-y(i)));
    dst(i)=sum(s);
end
[Rmin_lap, outb]=getb(dst, n, 2*2);
for u=5:floor((n-1)/2)
    [rate, b]=getb(dst, n, u);
    if  rate < Rmin_lap
        bestu=u;
        Rmin_lap=rate;
        outb=b;
    end    
end

end

function [rate, b] = getb(dst, n, u)
    b=zeros(1,n);
    temp=dst(1);
    for j=2:(u+1)
        temp=temp+dst(j);
    end    
    b(1) = max(realmin, (temp-dst(1))/u);
    rate = dst(1)/b(1)+log(b(1));
    
    for i=2:(u+1)           %nodes 2 to u+1
        temp= temp+dst(i+u);
        b(i) = max(realmin, (temp-dst(i))/(i+u));
        rate=rate+dst(i)/b(i)+log(b(i));
    end
    for j=1:u
        for i=1:u           %nodes 1 to n
            temp1= temp+dst(i);
            b1(i) = max(realmin, (temp1-dst(i))/(i+u));
            rate1=dst(i)/b1(i)+log(b1(i));
        end
    end
    for i=(u+2):(n-u)           %nodes u+2 to n-u
        temp= temp+dst(i+u)-dst(i-u-1);
        b(i) = max(realmin, (temp-dst(i))/(2*u));
        rate=rate+dst(i)/b(i)+log(b(i));
    end
    
    for i=(n-u+1):n           %nodes n-u+1 to n
        temp= temp-dst(i-u-1);
        b(i) = max(realmin, (temp-dst(i))/(n-1-i+u));
        rate=rate+dst(i)/b(i)+log(b(i));
    end
    
   
end

% void getb(int n, int u){
%     double temp = dst[0];
%     for(int j=1; j<=u; j++) temp += dst[j];
%     b[0] = max(SWBP_EPS, (temp-dst[0])/u);
%     double rate = dst[0]/b[0] + log(b[0]);
%     
%     for(int i=1; i<=u; i++){
%         temp += dst[i+u];
%         b[i] = max(SWBP_EPS, (temp-dst[i])/(i+u));
%         rate += dst[i]/b[i] + log(b[i]);
%     }
%     
%     for(int i=1+u; i<n-u; i++){
%         temp += (dst[i+u] - dst[i-u-1]);
%         b[i] = max(SWBP_EPS, (temp-dst[i])/(2*u));
%         rate += dst[i]/b[i] + log(b[i]);
%         if(rate>=rmin_lap){
%             return;
%         }
%     }
%     
%     for(int i=n-u; i<n; i++){
%         temp -= dst[i-u-1];
%         b[i] = max(SWBP_EPS, (temp-dst[i])/(n-1-i+u));
%         rate += dst[i]/b[i] + log(b[i]);
%         if(rate>=rmin_lap){
%             return;
%         }
%     }
%     
% //    cout<<rate<<" ";
%     
% //    if (rate<rmin_lap) {
%         rmin_lap = rate;
%         double *relay = b;
%         b = tmpb;
%         tmpb = relay;// swap b and tmpb
% //    }
% }



